/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 11.2
*/

#include<string>
#include<iostream>
#include<fstream>
using namespace std;


class Array
{
public:
  int n;
  double * e;

  void Allocate(int i)
  {
    e = new double[i];
    n = i;
  }
  void DeAllocate()
  {
    delete[] e;
    n = 0;
  }
  int length(){return n;}
  void set(int i, double value){e[i]=value;}
  double get(int i){return e[i];}
};


class Student
{
public:
  //--- Attributes 
  string Name, Family;
  int ID;
  Array Grade;

  //--- Methods 
  void set_Name(string str){Name = str;}
  void set_Family(string str){Family = str;}
  void set_ID(int stid){ID = stid;}
  void set_Grade(int i, double stgrd){Grade.e[i] = stgrd;}

  void Report()
  {
    cout << "------------------------------"<<endl;
    cout << "Name   : " << Name  << endl;
    cout << "Family : " << Family<< endl;
    cout << "ID     : " << ID    << endl;
    cout << "Grades : " ;
    int i;
    for(i=0;i<Grade.n;i++)
      cout << Grade.e[i] << ", ";
    cout << endl;
    cout << "------------------------------"<<endl;
  }

  void Report(string fileName)
  {
    ofstream fout(fileName.c_str());
    fout << "------------------------------"<<endl;
    fout << "Name   : " << Name  << endl;
    fout << "Family : " << Family<< endl;
    fout << "ID     : " << ID    << endl;
    fout << "Grades : ";
    int i;
    for(i=0;i<Grade.n;i++)
      fout << Grade.e[i] << ", ";
    fout << endl;
    fout << "------------------------------"<<endl;
    fout.close();
  }

};

int main()
{
  Student st1, st2;
  st1.set_Name("Farschad");
  st1.set_Family("Torabi");
  st1.set_ID(728841);
  st1.Grade.Allocate(3);
  st1.set_Grade(0,15.75);
  st1.set_Grade(1,13.00);
  st1.set_Grade(2,17.50);

  st2.set_Name("Ali");
  st2.set_Family("Rahmani");
  st2.set_ID(872078);
  st2.Grade.Allocate(4);
  st2.set_Grade(0,10.15);
  st2.set_Grade(1,18.20);
  st2.set_Grade(2,16.75);
  st2.set_Grade(3,14.75);

  st1.Report();
  st2.Report("Results.txt");

  cin>>st1.ID;
  return 0;
}
